#ifndef LEXER_H
#define LEXER_H

#include <stddef.h>

typedef struct {
    size_t index;
    int line, col;
} Position;

char* pos_string(Position pos, size_t length, const char* text);

typedef enum {
    TokenTypeEof,
    TokenTypeInvalidChar,
    TokenTypeInt,
    TokenTypePlus,
    TokenTypeMinus,
    TokenTypeAsterisk,
    TokenTypeSlash,
    TokenTypeLParen,
    TokenTypeRParen,
} TokenType;

const char* token_type_to_string(TokenType type);

typedef struct {
    TokenType type;
    size_t index, length;
    int line, col;
} Token;

char* token_to_string(Token* token, const char* text);

typedef struct {
    const char* text;
    size_t index, length;
    int line, col;
} Lexer;

void lexer(Lexer* lexer, const char* text, size_t length);
Token lexer_next(Lexer* lexer);

#endif
